Bug 2005917 - Backport: Upgradeable=False conditions to 4.8 /settings/cluster page
Summary: Backport: Upgradeable=False conditions to 4.8 /settings/cluster page
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Management Console
Version: 4.8
Hardware: Unspecified
OS: Unspecified
unspecified
medium
Target Milestone: ---
: 4.8.z
Assignee: Jakub Hadvig
QA Contact: Yadan Pei
URL:
Whiteboard:
Depends On: 2005493
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-09-20 13:30 UTC by Scott Dodson
Modified: 2021-09-27 19:53 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 2005493
Environment:
Last Closed: 2021-09-27 19:53:41 UTC
Target Upstream Version:


Attachments (Terms of Use)
Details page show not upgradable message (143.14 KB, image/png)
2021-09-22 03:26 UTC, Yadan Pei
no flags Details
link to not upgradable clusteroperators (119.68 KB, image/png)
2021-09-22 03:29 UTC, Yadan Pei
no flags Details


Links
System ID Private Priority Status Summary Last Updated
Github openshift console pull 10103 0 None open [release-4.8] Bug 2005917: CONSOLE-2152: Improve upgrade messaging when ClusterVersion Upgradeable=False 2021-09-20 13:44:49 UTC
Red Hat Product Errata RHBA-2021:3632 0 None None None 2021-09-27 19:53:45 UTC

Description Scott Dodson 2021-09-20 13:30:48 UTC
+++ This bug was initially created as a clone of Bug #2005493 +++

Please backport the improvements in CONSOLE-2152 to 4.8. At least specifically those to list out Upgradeable=False conditions on the /settings/cluster console page.

This will greatly improve the user experience as we add in an Admin Acknowledgement to 4.8.z which is implemented as an Upgradeable condition with a message directing the admin to review critical API removal documentation before acknowledging that by setting a configmap value.

--- Additional comment from Eric Paris on 2021-09-20 05:00:28 EDT ---

This bug sets Target Release equal to a z-stream but has no bug in the 'Depends On' field. As such this is not a valid bug state and the target release is being unset.

Any bug targeting 4.1.z must have a bug targeting 4.2 in 'Depends On.'
Similarly, any bug targeting 4.2.z must have a bug with Target Release of 4.3 in 'Depends On.'

Comment 1 Scott Dodson 2021-09-20 13:31:18 UTC
Hopefully this cloning of the bug appeases the eparis bug bot

Comment 2 Scott Dodson 2021-09-20 13:51:00 UTC
Patch manager, this is a feature backport which significantly improves the user experience around the admin acknowledgements which we intend to land in 4.8.z as a prerequisite to upgrading to 4.9. This makes Upgradeable=False conditions visible on the upgrade page so that the admin knows what they need to go resolve prior to attempting a minor version upgrade.

If you have any concerns about approving this please reach out to me.

Comment 5 Yadan Pei 2021-09-22 03:25:02 UTC
1. Create a ClusterOperator with Upgradeable=False
$ cat <<EOF >co.yaml 
apiVersion: config.openshift.io/v1
kind: ClusterOperator
metadata:
  name: testing
spec: {}
EOF
$ oc apply -f co.yaml
$ oc proxy &
$ curl -k -XPATCH -H "Accept: application/json" -H "Content-Type: application/json-patch+json"
 'http://127.0.0.1:8001/apis/config.openshift.io/v1/clusteroperators/testing/status'
 -d '[{"op": "add", "path": "/status", "value": {"conditions": [{"lastTransitionTime": "2021-06-01T01:01:01Z",
 "type": "Upgradeable", "status": "False", "reason": "Testing", "message": "The whatsits are broken."}]}}]'
2. wait for ClusterVersion/version to reconcile the changes 
$ oc get clusterversions.config.openshift.io version -o yaml|grep Upgradeable -B5
  - lastTransitionTime: "2021-09-22T03:17:14Z"
    message: 'Cluster operator testing cannot be upgraded between minor versions:
      The whatsits are broken.'
    reason: Testing
    status: "False"
    type: Upgradeable

3. Check Cluster Settings Details page, warning message will be shown on the page with a link to the not upgradeable clusteroperators, see screenshot

Verified on 4.8.0-0.nightly-2021-09-21-191721

Comment 6 Yadan Pei 2021-09-22 03:26:25 UTC
Created attachment 1825169 [details]
Details page show not upgradable message

Comment 7 Yadan Pei 2021-09-22 03:29:42 UTC
Created attachment 1825170 [details]
link to not upgradable clusteroperators

Comment 10 errata-xmlrpc 2021-09-27 19:53:41 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (OpenShift Container Platform 4.8.13 bug fix update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2021:3632


Note You need to log in before you can comment on or make changes to this bug.